from interface import *
import random

class Bot:

    def mouse_going_to_dough_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the dough station on tick {arrival_tick}")

    def mouse_going_to_chocolate_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the chocolate station on tick {arrival_tick}")

    def mouse_going_to_lemon_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the lemons station on tick {arrival_tick}")

    def mouse_going_to_bowl_filling_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the bowl filling station on tick {arrival_tick}")

    def mouse_going_to_mixing_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the mixing station on tick {arrival_tick}")

    def mouse_going_to_cup_filling_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the cup filling station on tick {arrival_tick}")

    def mouse_going_to_baking_station(self, mouse, arrival_tick):
        print(f"Mouse {mouse.id} is going to arrive at the baking station on tick {arrival_tick}")

    def mouse_getting_dough(self, mouse, finish_tick):
        print(f"Mouse {mouse.id} is getting {self.contexts.dough.max_amount} dough and will finish on tick {finish_tick}")
        
    def mouse_getting_chocolate(self, mouse, finish_tick):
        print(f"Mouse {mouse.id} is getting {self.contexts.chocolate.max_amount} chocolate and will finish on tick {finish_tick}")
        
    def mouse_getting_lemons(self, mouse, finish_tick):
        print(f"Mouse {mouse.id} is getting {self.contexts.lemons.max_amount} lemons and will finish on tick {finish_tick}")

    def mouse_filling_bowls(self, mouse, bowl, resource_id, old_storages, finish_tick):
        if resource_id == 1:
            print(f"Mouse {mouse.id} is filling 1 chocolates and 1 dough into bowl {bowl.id} and will finish on tick {finish_tick}")
        if resource_id == 2:
            print(f"Mouse {mouse.id} is filling 1 lemons and 1 dough into bowl {bowl.id} and will finish on tick {finish_tick}")

    def mouse_mixing_bowl(self, mouse, bowl, finish_tick):
        print(f"Mouse {mouse.id} is mixing the contents of bowl {bowl.id} and will finish on tick {finish_tick}")

    def mouse_filling_cups(self, mouse, bowl, old_storages, finish_tick):
        print(f"Mouse {mouse.id} is filling 1 cups from the contents of bowl {bowl.id} and will finish on tick {finish_tick}")

    def mouse_baking_muffins(self, mouse, old_storages, finish_tick):
        print(f"Mouse {mouse.id} is putting the {sum(old_storages.cups.values())} cups into the oven and will finish on tick {finish_tick}. The oven will finish baking on tick {finish_tick + self.contexts.baking.baking_time}")
        self.baking_until = finish_tick + self.contexts.baking.baking_time

    def mouse_idling(self, mouse, finish_tick):
        print(f"Mouse {mouse.id} is AFK until {finish_tick}, what a noob.")

    def print_mouse_stats(self):
        
        print(f"My mouse has id {self.my_id}")
        print(f"My mouse takes {self.mice[self.my_id].dough_fetching_speed} ticks to fetch dough")
        print(f"My mouse takes {self.mice[self.my_id].chocolate_fetching_speed} ticks to fetch chocolate")
        print(f"My mouse takes {self.mice[self.my_id].lemon_fetching_speed} ticks to fetch lemons")
        print(f"My mouse takes {self.mice[self.my_id].bowl_filling_speed} ticks per resource to fill a bowl")
        print(f"My mouse takes {self.mice[self.my_id].mixing_speed} ticks to mix a bowl")
        print(f"My mouse takes {self.mice[self.my_id].cup_filling_speed} ticks per resource to fill into cups")
        print(f"My mouse takes {self.mice[self.my_id].baking_speed} ticks to move all cups into the oven")

    def print_orders(self):

        print(f"There are {len(self.orders)} orders:")
        for order in self.orders:
            if order.muffin_type == 1:
                print(f"{order.amount} chocolate muffins should be finished by tick {order.tick}")
            if order.muffin_type == 2:
                print(f"{order.amount} lemon muffins should be finished by tick {order.tick}")

    def print_storages(self):

        print(f"There are {len(self.storages.bowls)} bowls with a capacity of {self.storages.bowls[0].capacity} available")
        print(f"There are {self.storages.max_cups} muffin cups available")

    # Mice:    list of `Mouse`, indexed by their id
    # my_id:   zero-based index of your Mouse in the Mice list.
    # orders:  list of `Order`, the orders you should fulfill
    # storages:
    def __init__(self, storages, contexts, mice, my_id, orders):
        self.mice = mice
        self.my_id = my_id
        self.orders = orders
        self.storages = storages
        self.contexts = contexts
        self.baking_until = 0
        self.print_mouse_stats()
        self.print_orders()
        self.print_storages()
        
    def main(self):
        while True:
            go_to(self.contexts.dough); # go to dough storage
            get_dough();
            go_to(self.contexts.chocolate); # go to chocolate storage
            get_chocolate();
            go_to(self.contexts.lemons); # go to lemon storage
            get_lemons();
            go_to(self.contexts.bowl_filling); # go to bowl filling station
            while(self.storages.bowls[0].in_use or self.storages.bowls[0].mixed):
                idle()
            fill_bowl(self.storages.bowls[0], 1); # fill bowl 0 with 1 unit of chocolate and one unit of dough
            go_to(self.contexts.mixing); # go to bowl mixing station
            if (not self.storages.bowls[0].mixed):
                while(self.storages.bowls[0].in_use):
                    idle()
                if (not self.storages.bowls[0].mixed):
                    mix_bowl(self.storages.bowls[0]); # mix bowl 0
            go_to(self.contexts.cup_filling); # go to cup filling station
            while(self.storages.bowls[0].in_use):
                idle()
            fill_cups(self.storages.bowls[0]); #fill 1 cup with chocolate dough
            fill_cups(self.storages.bowls[0]); #fill another cup with chocolate dough
            go_to(self.contexts.baking); # go to oven
            if (get_current_tick() < self.baking_until):
                idle(self.baking_until)
            bake_muffins(); #bake the 2 cups
            print(f"It is now tick {get_current_tick()}")

        

run(Bot)
